

<template>
    <div class="modal" v-if="isVisible">
        <div class="modal-background" @click="close"></div>
        <div class="modal-content">
            <form class="form"
                  novalidate
                  @submit.prevent="handleSubmit"
                  enctype="multipart/form-data">
                <FormModalForm :nolabel="props.nolabel"
                               :options="props.options"
                               :model="numeroLot"
                               :title="t('reintialiser.info') +props.nomSelectionne"
                               @handle-validation="handleValidation"
                               @register-form-select-ref="addFormSelectRef" />
                <FormRow>


                    <button class=" form__submit btn btn--fullscreen" type="submit">
                        {{ t("global.save") }}
                    </button>

                    <button class=" form__submit btn btn--fullscreen" type="button" @click="close">{{t("global.cancel")}}</button>

                </FormRow>


            </form>
        </div>
    </div>
</template>

<script lang="ts" setup>
    import FormInput from "@/components/forms/FormInput.vue"
    import FormSelect from "@/components/forms/FormSelect.vue"
    import { FormOption } from "@/types/formOption";
    import { NumLot } from "@/types/entities"
    import FormRow from "@/components/forms/FormRow.vue"
    import FormModalForm from "@/components/reintialiser/FormModalForm.vue"
    import { ref, watch } from "vue"
    import { useI18n } from "vue3-i18n"
    import { notifyError } from "@/notify"
    import { Status } from "@/validation"

    // eslint-disable-next-line no-undef
    const props = defineProps<{
        nolabel: boolean,
        options: FormOption[],
        nomSelectionne:string
        isVisible: boolean
    }>()

    const numeroLot = ref<NumLot>({})


    // eslint-disable-next-line
    const emit = defineEmits<{
        (event: "formSubmit", numero: string): void
        (event: "update:isVisible", value: boolean): void

    }>()



    const close = () => {

        emit('update:isVisible', false);

    };

    const { t } = useI18n()




    const formSelect = ref<any[]>([])
    const inputValidationStatuses: any = {}


    function addFormSelectRef(ref: typeof FormSelect) {
        if (!formSelect.value.includes(ref) && ref)
            formSelect.value.push(ref)
    }


    async function handleValidation(name: string, validationStatus: Status) {
        inputValidationStatuses[name] = validationStatus.valid
    }

    async function handleSubmit() {
        formSelect.value.forEach((x: typeof FormSelect) =>  x.validateInput())
        if (Object.values(inputValidationStatuses).some(x => x === false)) {
            notifyError(t('global.formErrorNotification'))
            return
        }
        emit("formSubmit", numeroLot.value.numeroLot!)
    }

</script>
<style scoped>
    .modal {
        position: fixed;
        z-index: 9998;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background-color: rgba(0, 0, 0, 0.6);
        display: flex;
        justify-content: center;
        align-items: center;
    }

    .modal-background {
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
    }

    .modal-content {
        z-index: 9999;
        background: white;
        padding: 20px;
        border-radius: 5px;
        box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);
    }
</style>